searchNodes=[{"type":"module","title":"Emit","doc":"","ref":"Emit.html"},{"type":"function","title":"Emit.pub/2","doc":"","ref":"Emit.html#pub/2"},{"type":"function","title":"Emit.query/1","doc":"","ref":"Emit.html#query/1"},{"type":"function","title":"Emit.sub/3","doc":"","ref":"Emit.html#sub/3"},{"type":"function","title":"Emit.unsub/2","doc":"","ref":"Emit.html#unsub/2"},{"type":"function","title":"Emit.unsub_auto/2","doc":"","ref":"Emit.html#unsub_auto/2"},{"type":"module","title":"Emit.Cluster","doc":"","ref":"Emit.Cluster.html"},{"type":"function","title":"Emit.Cluster.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Emit.Cluster.html#child_spec/1"},{"type":"function","title":"Emit.Cluster.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Emit.Cluster.html#init/1"},{"type":"function","title":"Emit.Cluster.monitor_nodes/0","doc":"","ref":"Emit.Cluster.html#monitor_nodes/0"},{"type":"function","title":"Emit.Cluster.start_link/1","doc":"","ref":"Emit.Cluster.html#start_link/1"},{"type":"function","title":"Emit.Cluster.task_supervisor/0","doc":"","ref":"Emit.Cluster.html#task_supervisor/0"},{"type":"module","title":"Emit.DB","doc":"","ref":"Emit.DB.html"},{"type":"function","title":"Emit.DB.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Emit.DB.html#child_spec/1"},{"type":"function","title":"Emit.DB.count/1","doc":"","ref":"Emit.DB.html#count/1"},{"type":"function","title":"Emit.DB.default_table/0","doc":"","ref":"Emit.DB.html#default_table/0"},{"type":"function","title":"Emit.DB.del/2","doc":"","ref":"Emit.DB.html#del/2"},{"type":"function","title":"Emit.DB.get/2","doc":"","ref":"Emit.DB.html#get/2"},{"type":"function","title":"Emit.DB.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Emit.DB.html#init/1"},{"type":"function","title":"Emit.DB.new_query/1","doc":"","ref":"Emit.DB.html#new_query/1"},{"type":"function","title":"Emit.DB.query/1","doc":"","ref":"Emit.DB.html#query/1"},{"type":"function","title":"Emit.DB.restart/0","doc":"","ref":"Emit.DB.html#restart/0"},{"type":"function","title":"Emit.DB.set/3","doc":"","ref":"Emit.DB.html#set/3"},{"type":"function","title":"Emit.DB.start_link/1","doc":"","ref":"Emit.DB.html#start_link/1"},{"type":"function","title":"Emit.DB.stop/1","doc":"","ref":"Emit.DB.html#stop/1"},{"type":"extras","title":"Emit","doc":"Powerful metadata-backed pubsub for Elixir. Emit is a pubsub library that allows controlling the receivers of messages through granular metadata queries. pids that subscribe to Emit messages can set metadata about itself -- basically just a map with any keys/values the user wants -- and messages can be sent to pids matching certain metadata. For example, you could use this to send a message to all pids that have been waiting more than 30 seconds: require Lethe query = Emit . query ( ) |&gt; Lethe . where ( map_get ( :wait_time , :metadata ) &gt;= 30_000 ) Emit . pub { :my_message , &quot;some data&quot; } , query Or you could push a message to all pids for a specific user: require Lethe user_id = ... query = Emit . query ( ) |&gt; Lethe . where ( map_get ( :user_id , :metadata ) == ^ user_id ) Emit . pub :disconnect , query Emit will always be slower than a basic pubsub system, due to the fact that it has to query an in-memory database on each message send. Emit works transparently across nodes.","ref":"readme.html"},{"type":"extras","title":"Emit - Usage","doc":"Get it from Hex and add to mix.exs Add config :emit, :task_scheduler, MyApp.Emit.TaskScheduler to config.exs Add {Task.Supervisor, name: MyApp.Emit.TaskScheduler} towards the top of your supervision tree Add Emit.Cluster to your supervision tree, after libcluster or similar Add Emit.DB to your supervision tree, after Emit.Cluster","ref":"readme.html#usage"},{"type":"extras","title":"Emit - API","doc":"Subscribe to messages, setting some metadata about the pid Emit . sub %{ key : &quot;value&quot; } Unsubscribe this pid from Emit messages Emit . unsub ( ) Automatically unsubscribe from Emit messages when this pid stops Emit . unsub_auto ( ) Push messages # Broadcast a message to all clients Emit . pub :hello_world , Emit . query ( ) # Broadcast a message to all clients that have `key: &quot;value&quot;` in their metadata # Emit queries are powered by Lethe: https://github.com/queer/lethe require Lethe query = Emit . query ( ) |&gt; Lethe . where ( map_get ( :key , :metadata ) == &quot;value&quot; ) Emit . pub :hello_world , query Complex metadata require Lethe # Set some deeply-nested metadata Emit . sub % { key : %{ key2 : %{ &quot;value&quot; } } query = Emit . query ( ) |&gt; Lethe . where ( map_get ( :key2 , map_get ( :key , :metadata ) ) == &quot;value&quot; ) Emit . pub :hello_world , query Benchmarks Please run your own benchmarks to determine if Emit is suitable for your use-case!!! The machine this was benchmarked on is quite high-end relative to most developer workstations etc. Benchmarks (1k clients) git : ( mistress ) 10 | ▶ mix bench . 1 k 11 : 15 : 07.892 [ debug ] [ EMIT ] [ CLUSTER ] boot : node : monitor up 11 : 15 : 07.896 [ notice ] Application mnesia exited : :stopped Operating System : Linux CPU Information : AMD Ryzen Threadripper 3960 X 24 - Core Processor Number of Available Cores : 48 Available memory : 251.62 GB Elixir 1.13 . 4 Erlang 24.3 . 4 Benchmark suite executing with the following configuration : warmup : 2 s time : 5 s memory time : 0 ns reduction time : 0 ns parallel : 8 inputs : none specified Estimated total run time : 28 s Benchmarking sending messages to all 1000 clients ... Benchmarking sending messages to only 100 clients ... Benchmarking sending messages to only 50 clients ... Benchmarking sending messages to only 500 clients ... Name ips average deviation median 99 th % sending messages to only 100 clients 3.11 K 321.96 μs ± 38.37 % 298.17 μs 618.06 μs sending messages to only 500 clients 2.82 K 354.12 μs ± 25.38 % 343.55 μs 618.60 μs sending messages to only 50 clients 2.78 K 359.52 μs ± 26.43 % 347.99 μs 633.01 μs sending messages to all 1000 clients 1.24 K 805.97 μs ± 28.84 % 758.06 μs 1491.08 μs Comparison : sending messages to only 100 clients 3.11 K sending messages to only 500 clients 2.82 K - 1.10 x slower + 32.16 μs sending messages to only 50 clients 2.78 K - 1.12 x slower + 37.56 μs sending messages to all 1000 clients 1.24 K - 2.50 x slower + 484.02 μs git : ( mistress ) 10 | ▶ Benchmarks (10k clients) git : ( mistress ) 10 | ▶ mix bench . 10 k 11 : 15 : 52.647 [ debug ] [ EMIT ] [ CLUSTER ] boot : node : monitor up 11 : 15 : 52.650 [ notice ] Application mnesia exited : :stopped Operating System : Linux CPU Information : AMD Ryzen Threadripper 3960 X 24 - Core Processor Number of Available Cores : 48 Available memory : 251.62 GB Elixir 1.13 . 4 Erlang 24.3 . 4 Benchmark suite executing with the following configuration : warmup : 2 s time : 5 s memory time : 0 ns reduction time : 0 ns parallel : 8 inputs : none specified Estimated total run time : 28 s Benchmarking sending messages to all 10 k clients ... Benchmarking sending messages to only 1 k clients ... Benchmarking sending messages to only 500 clients ... Benchmarking sending messages to only 5 k clients ... Name ips average deviation median 99 th % sending messages to only 500 clients 967.03 1.03 ms ± 17.09 % 1.00 ms 1.64 ms sending messages to only 5 k clients 946.15 1.06 ms ± 17.49 % 1.02 ms 1.71 ms sending messages to only 1 k clients 933.83 1.07 ms ± 23.72 % 1.03 ms 1.75 ms sending messages to all 10 k clients 174.44 5.73 ms ± 22.20 % 5.52 ms 9.47 ms Comparison : sending messages to only 500 clients 967.03 sending messages to only 5 k clients 946.15 - 1.02 x slower + 0.0228 ms sending messages to only 1 k clients 933.83 - 1.04 x slower + 0.0368 ms sending messages to all 10 k clients 174.44 - 5.54 x slower + 4.70 ms git : ( mistress ) 10 | ▶ Benchmarks (100k clients) git : ( mistress ) 10 | ▶ mix bench . 100 k 11 : 16 : 36.182 [ debug ] [ EMIT ] [ CLUSTER ] boot : node : monitor up 11 : 16 : 36.186 [ notice ] Application mnesia exited : :stopped Operating System : Linux CPU Information : AMD Ryzen Threadripper 3960 X 24 - Core Processor Number of Available Cores : 48 Available memory : 251.62 GB Elixir 1.13 . 4 Erlang 24.3 . 4 Benchmark suite executing with the following configuration : warmup : 2 s time : 5 s memory time : 0 ns reduction time : 0 ns parallel : 8 inputs : none specified Estimated total run time : 28 s Benchmarking sending messages to all 100 k clients ... Benchmarking sending messages to only 10 k clients ... Benchmarking sending messages to only 50 k clients ... Benchmarking sending messages to only 5 k clients ... Name ips average deviation median 99 th % sending messages to only 5 k clients 58.56 17.08 ms ± 8.50 % 17.04 ms 20.20 ms sending messages to only 50 k clients 57.75 17.32 ms ± 10.10 % 17.26 ms 21.96 ms sending messages to only 10 k clients 56.91 17.57 ms ± 17.55 % 17.37 ms 26.96 ms sending messages to all 100 k clients 10.98 91.09 ms ± 9.96 % 90.61 ms 112.20 ms Comparison : sending messages to only 5 k clients 58.56 sending messages to only 50 k clients 57.75 - 1.01 x slower + 0.24 ms sending messages to only 10 k clients 56.91 - 1.03 x slower + 0.50 ms sending messages to all 100 k clients 10.98 - 5.33 x slower + 74.02 ms git : ( mistress ) 10 | ▶","ref":"readme.html#api"},{"type":"extras","title":"Emit - Key points","doc":"It works! :D Performance scaling is about one order of magnitude of time per order of magnitude of number of clients. For example, if 10 pids takes 10ms, 100 pids takes 100ms, 1000 pids takes 1000ms, etc. Performace is great at low numbers of pids, and is acceptable even when pushing messages to up to 50k out of 100k pids.","ref":"readme.html#key-points"}]